#!/bin/bash
#Automatically Created by buildpkg 1.0.5
#Maintainer: Matthew Bruenig <matthewbruenig@gmail.com>

######Begin Redundant Code######################################
check_for_root() {
	if [ "$UID" != "0" ]; then
		echo "You need to be root"
		exit 1
	fi
}

clean_old_builds () {
	for COMPLETED in $package.{tgz,md5,dep} src pkg; do
		if [ -e $COMPLETED ]; then
			rm -rf $COMPLETED
		fi
	done
}

set_pre_permissions() {
	cd $startdir/src
	find . -perm 664 -exec chmod 644 {} \;
	find . -perm 600 -exec chmod 644 {} \;
	find . -perm 444 -exec chmod 644 {} \;
	find . -perm 400 -exec chmod 644 {} \;
	find . -perm 440 -exec chmod 644 {} \;
	find . -perm 777 -exec chmod 755 {} \;
	find . -perm 775 -exec chmod 755 {} \;
	find . -perm 511 -exec chmod 755 {} \;
	find . -perm 711 -exec chmod 755 {} \;
	find . -perm 555 -exec chmod 755 {} \;
}


check_for_menu_complaince() {
	if [ -d "$startdir/pkg/usr/share/applications" ]; then
		cd $startdir/pkg/usr/share/applications
		for desktop in *.desktop; do
			. $desktop 2>/dev/null
			if [[ "$Icon" ]]; then
				if [ ! "$Icon" == "${Icon%.*}" ]; then
					sed '/Icon/s/\..*$//' -i $desktop
					. $desktop 2>/dev/null
				fi
				if [ -d "$startdir/pkg/usr/share/pixmaps" ]; then
					cd $startdir/pkg/usr/share/pixmaps
					for pixmaps in *; do
				 		if [ "${pixmaps%.*}" == "$Icon" ]; then
				 			DIR=$(file $pixmaps | awk -F, '{print $2}' | sed 's/ //g')
							mkdir -p $startdir/pkg/usr/share/icons/hicolor/$DIR/apps
							mv $pixmaps $startdir/pkg/usr/share/icons/hicolor/$DIR/apps
							if [[ ! "$(ls $startdir/pkg/usr/share/pixmaps)" ]]; then
								rm -rf $startdir/pkg/usr/share/pixmaps
							fi
						fi
					done
				fi
				if [ -d "$startdir/pkg/usr/share/icons" ]; then
					cd $startdir/pkg/usr/share/icons
					for icons in *; do
				 		if [ "${icons%.*}" == "$Icon" ]; then
				 			DIR=$(file $icons | awk -F, '{print $2}' | sed 's/ //g')
							mkdir -p $startdir/pkg/usr/share/icons/hicolor/$DIR/apps
							mv $icons $startdir/pkg/usr/share/icons/hicolor/$DIR/apps
						fi
					done
				fi
			fi
		done
	fi
}

strip_binaries() {
	cd $startdir/pkg
	find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | \
	xargs strip --strip-unneeded 2> /dev/null
	find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | \
	xargs strip --strip-unneeded 2> /dev/null
}

gzip_man_and_info_pages() {
	for DOCS in man info; do
		if [ -d "$startdir/pkg/usr/share/$DOCS" ]; then
			mv $startdir/pkg/usr/share/$DOCS $startdir/pkg/usr/$DOCS
			if [[ ! "$(ls $startdir/pkg/usr/share)" ]]; then
				rm -rf $startdir/pkg/usr/share
			fi
		fi
		if [ -d "$startdir/pkg/usr/$DOCS" ]; then
			find $startdir/pkg/usr/$DOCS -type f -exec gzip -9 '{}' \;
		fi
	done
}

set_post_permissions() {
	if [ -d "$startdir/pkg/usr/bin" ]; then
		chown -R root:root $startdir/pkg/usr/bin
	fi
}

copy_build_script() {
	mkdir -p $startdir/pkg/usr/src/$pkgname-$pkgver
	cp $startdir/build-$pkgname.sh $startdir/pkg/usr/src/$pkgname-$pkgver/build-$pkgname.sh
}

create_package() {
	cd $startdir/pkg
	makepkg -l y -c n $startdir/$package.tgz
	cd $startdir
	md5sum $package.tgz > $startdir/$package.md5
}

clean() {
	rm -rf $startdir/pkg $startdir/src
}


#########End Redundant Code#####################################
#########Begin Non Redundant Code##############################

prepare_directory() {
	mkdir $startdir/src
	for SOURCES in http://www.limitland.de/ComixCursors-0.4.3.tar.bz2 http://xfce-look.org/CONTENT/content-files/5533-Silver-XCursors-3D-0.4.tar.bz2 19506-pinuxs-tux-cursors-theme-0.3-cur.tar.bz2 http://xfce-look.org/CONTENT/content-files/14484-Grounation-0.3.tar.bz2 http://xfce-look.org/CONTENT/content-files/27913-PolarCursorThemes.tar.bz2 http://xfce-look.org/CONTENT/content-files/6550-Jimmac.tar.gz http://xfce-look.org/CONTENT/content-files/13524-panther-1.1.tar.gz http://xfce-look.org/CONTENT/content-files/14775-jaguarx.tar.bz2 http://xfce-look.org/CONTENT/content-files/28310-neutral-1.13a.tar.gz http://xfce-look.org/CONTENT/content-files/5507-Golden-XCursors-3D-0.8.tar.bz2; do
		if [ ! -f "$(basename $SOURCES)" ]; then
			protocol=$(echo $SOURCES | sed 's|:.*||')
			if [ "$protocol" = "http" -o "$protocol" = "https" -o "$protocol" = "ftp" ]; then
				echo -e "\nDownloading $(basename $SOURCES)\n"
				wget $SOURCES
				if [ ! "$?" == "0" ]; then
					echo "Download failed"
					exit 2
				fi 
			else
				echo "$SOURCES does not appear to be a url nor is it in the directory"
				exit 2
			fi
		fi
		cp -R $(basename $SOURCES) $startdir/src
	done
	cd $startdir/src
	if [[ "$(ls $startdir/src)" ]]; then	
		for FILES in *; do
			if [[ "$(echo $FILES | grep tar)" ]]; then
				tar xf $FILES
			fi
		done
	else
		echo "no files in the src directory $startdir/src"
		exit 2
	fi
	mkdir $startdir/pkg
}

build() {
	cd $SRC
	mkdir -p $PKG/usr/share/icons
	mkdir -p $PKG/usr/doc/$pkgname-$pkgver

	#pantherx
	mkdir -p $PKG/usr/doc/$pkgname-$pkgver/pantherx
	( cd panther
	tar xf pantherx.tar.gz
	mv pantherx/{License,README} $PKG/usr/doc/$pkgname-$pkgver/pantherx
	cp -r pantherx $PKG/usr/share/icons )

	#Grounation
	mkdir -p $PKG/usr/doc/$pkgname-$pkgver/Grounation
	( cd Grounation-0.3
	cp {NEWS,README,COPYING} $PKG/usr/doc/$pkgname-$pkgver/Grounation
	rm -rf Grounation{,-left}/Source
	cp -r Grounation{,-left} $PKG/usr/share/icons )

	#jaguarx
	rm -rf jaguarx/source
	cp -r jaguarx $PKG/usr/share/icons

	#tuxcursors (tarbomb)
	mkdir -p $PKG/usr/doc/$pkgname-$pkgver/tuxcursors
	cp {COPYRIGHT,LICENSE,README} $PKG/usr/doc/$pkgname-$pkgver/tuxcursors
	cp -r cursors/pTux-32 $PKG/usr/share/icons/tuxcursors

	#PolarCursor		
	mkdir -p $PKG/usr/doc/$pkgname-$pkgver/PolarCursor
	cp PolarCursorTheme/COPYRIGHT~ $PKG/usr/doc/$pkgname-$pkgver/PolarCursor
	rm -rf PolarCursorTheme*/{COPYRIGHT~,index.theme~,Source}
	cp -r PolarCursorTheme* $PKG/usr/share/icons
	
	#neutral
	mkdir -p $PKG/usr/doc/$pkgname-$pkgver/neutral
	mv neutral/{COPYRIGHT,LICENSE} $PKG/usr/doc/$pkgname-$pkgver/neutral
	rm -rf neutral/source
	cp -r neutral $PKG/usr/share/icons

	#Silver
	mkdir -p $PKG/usr/doc/$pkgname-$pkgver/Silver
	( cd Silver-XCursors-3D-0.4
	mv {COPYING,README} $PKG/usr/doc/$pkgname-$pkgver/Silver
	cp -r Silver $PKG/usr/share/icons )

	#jimmac
	mkdir -p $PKG/usr/doc/$pkgname-$pkgver/jimmac
	cp Jimmac/{COPYING,README} $PKG/usr/doc/$pkgname-$pkgver/jimmac
	cp -r Jimmac/jimmac $PKG/usr/share/icons

	#ComixCursors
	rm -rf ComixCursors-0.4.3.tar.bz2
	cp -r ComixCursors* $PKG/usr/share/icons

	#Gold
	mkdir -p $PKG/usr/doc/$pkgname-$pkgver/Gold
	( cd Golden-XCursors-3D-0.8
	mv {COPYING,README} $PKG/usr/doc/$pkgname-$pkgver/Gold
	cp -r Gold $PKG/usr/share/icons )
} 

create_slackdesc() {
mkdir $startdir/pkg/install
cat <<"EODESC" >$startdir/pkg/install/slack-desc
extra-mouse-themes: extra-mouse-themes - themes from xfce-look.org
extra-mouse-themes: 
extra-mouse-themes: These ten themes from xfce-look.org all in the top 15 downloaded:
extra-mouse-themes: pantherx, Grounation, jaguarx, tuxcursors, PolarCursor, neutral,
extra-mouse-themes: jimmac, ComixCursors, Gold, Silver. Some themes have multiple themes
extra-mouse-themes: within them.
extra-mouse-themes: 
extra-mouse-themes: 
extra-mouse-themes: 
extra-mouse-themes: 
extra-mouse-themes: 
EODESC
}

detect_dependencies() {
	echo "Detecting dependencies..."
	depends=$(requiredbuilder -z $startdir/$package.tgz)
	
	depstring=$depends
	unset FIRST
	for deps in $(echo "${depstring}" | sed 's/,/\n/g' | sort); do
		if [[ ! "$FIRST" ]]; then
			finaldeps=$deps,
			FIRST='1'
			continue
		fi
		finaldeps=${finaldeps}${deps},
	done
	echo "$finaldeps" | sed -e 's/^,//' -e 's/,$//' > $startdir/$package.dep
}

####End Non Redundant Code############################

#Variables

startdir=$(pwd)
SRC=$startdir/src
PKG=$startdir/pkg

pkgname=extra-mouse-themes
pkgver=1.0
pkgrel=1
zenver=48
arch=i486
package=$pkgname-$pkgver-$arch-$zenver.$pkgrel
export CFLAGS="-O2 -march=$arch -mtune=i686"
export CXXFLAGS="-O2 -march=$arch -mtune=i686"

#Execution

check_for_root
clean_old_builds
prepare_directory
set_pre_permissions
build
if [ ! "$?" = "0" ]; then
	echo "build() failed."
	exit 2
fi
create_slackdesc
check_for_menu_complaince
strip_binaries
gzip_man_and_info_pages
set_post_permissions
copy_build_script
create_package
detect_dependencies
#clean
echo "Package has been built."
